#include <bastard.h>
#include <bdb.h>
#include <extension.h>


   int plugin_main( void *param){
   struct DISASM_TGT *target;
      struct function f;
      int cont;

      target = env_get_target();

   
      /* PREDISASM phase: parse the file header */
      if ( target->status < DISASM_TGT_PREDISASM ) 
         if (! target_apply_format() ) return(sys_set_lasterr(4570));
      target->status = DISASM_TGT_PREDISASM;

      /* DISASM phase */
      /* Start by disassembling all functions recognized by the format parser */
      sys_msg("Disassembling named symbols. Instruction stack:\n");

      cont = db_index_first(FUNCTION_RVA, &f);
      while (cont) {
         disasm_forward(f.rva);
         cont = db_index_next(FUNCTION_RVA, &f);
      }
   
      /* Then attack the entry point */
      sys_msg("Disassembling forward from entry point. Instruction stack:\n");
      disasm_forward(target->entry);
      target->status = DISASM_TGT_DISASM;


      /* POSTDISASM Phase */
      /* create an export and a function for the entry point */
      exp_new(target->entry, "_start");
      func_new(target->entry, "_start", 1, 0);
      sys_msg("Performing post-disassembly passes\n");
      disasm_all_passes();
      target->status = DISASM_TGT_POSTDISASM;

      /* OK, done, return to base */
      sys_msg("Done.\n");
      return(1);
   }

