#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <errno.h>
#include <limits.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <bastard.h>

#include "sob_bastard.h"
#include "sob_extensions.h"
#include "sob_ui.h"



/* goddamn global widget pointers */
GtkWidget *about_dlg = NULL, 
          *select_file_dlg = NULL;

/* ----------------------------------------------------------------- */
void
on_load_target1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{  
   if (load_file_dlg.self == NULL) {
       load_file_dlg.self = create_LoadFileDlg(); 
       init_load_file_dlg();
   }

   gtk_widget_show(load_file_dlg.self);
   /* create_fSelectFontDialog create_SelectFileDlg */
   /* to unload:
    *   void
    *   on_save_filesel_cancel_button_clicked       (GtkButton       *button,
    *                       gpointer         user_data)
    *                       {
    *                         gtk_widget_hide (gtk_widget_get_toplevel (GTK_WIDGET (button)));
    *                         }
    */
}


void
on_load_bdb1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   /* Save DB */

}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_close1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   /* Close DB */
   /* Reset UI */
}


void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   sys_quit();
   env_set_flag( QUIT_NOW );
   exit(0);
}


void
on_edit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_find1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_settings1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_refresh_asm1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_refesh_names1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_refresh_functions1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_refresh_strings1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_refresh_sections1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_refresh_imports1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_help1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about2_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   /* call about dialog */
   if (about_dlg == NULL)
      about_dlg = create_AboutDlg();
   gtk_widget_show(about_dlg);

}


void
on_LoadFileDlg_show                    (GtkWidget       *widget,
                                        gpointer         user_data)
{
   return;

}


void
loadfile_browse_ok                      (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_entry_set_text(
         GTK_ENTRY(lookup_widget( load_file_dlg.self, "lfd_file_entry")), 
         gtk_file_selection_get_filename(select_file_dlg)                 );
   gtk_widget_hide(select_file_dlg);

   return;
}

void
loadfile_dlg_browse                    (GtkButton       *button,
                                        gpointer         user_data)
{
   /* show file sel dialog */
   if (select_file_dlg == NULL) 
      select_file_dlg = create_SelectFileDlg(); 

   //gtk_file_selection_show_fileop_buttons(select_file_dlg);
   gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (
               select_file_dlg)->ok_button), "clicked", 
         (GtkSignalFunc) loadfile_browse_ok, select_file_dlg );
   gtk_widget_show(select_file_dlg);
   return;
}


void
loadfile_dlg_format_change             (GtkEditable     *editable,
                                        gpointer         user_data)
{
   GtkEntry *entry;
   char filename[PATH_MAX];
   
   entry = GTK_ENTRY(lookup_widget(load_file_dlg.self, "lfd_format_entry")); 

   /* create options based on .dat file */
   sprintf(filename, "%s/formats/%s.dat", env_get_home(), 
         gtk_entry_get_text(entry));

   create_dlg_from_datfile( filename,  &load_file_dlg.format);

   /* here's how you make dynamic widgets :P */
   /*
   label = gtk_label_new(format);
   gtk_widget_set_name(label, "fmtlabel");
   gtk_box_pack_start(vbox13, label, TRUE, FALSE, 0);
   gtk_widget_show(label);
   */
   return;

}


void
loadfile_dlg_cpu_change                (GtkEditable     *editable,
                                        gpointer         user_data)
{
   GtkEntry *entry;
   char filename[PATH_MAX];
   
   entry = GTK_ENTRY(lookup_widget( load_file_dlg.self, "lfd_cpu_entry")); 

   /* create options based on .dat file */
   sprintf(filename, "%s/arch/%s.dat", env_get_home(), 
         gtk_entry_get_text(entry));

   create_dlg_from_datfile( filename, &load_file_dlg.cpu);
   return;
}

void loadfile_ok_foreach(GtkWidget *widget, gpointer data) {
   int val, *option = data;
   
   if ( (val = (int) gtk_object_get_data(GTK_OBJECT(widget), "value")) &&
         gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(widget) )) {
      /* OR option with value for checkbox/radio button */
      *option |= val;
   } 
   return;
}

void
loadfile_dlg_ok                        (GtkButton       *button,
                                        gpointer         user_data)
{
   struct stat s;
   GtkVBox *vbox;
   GList *children, *ptr;
   int x, option = 0;

   GtkEntry *entry = 
      GTK_ENTRY(lookup_widget( load_file_dlg.self, "lfd_file_entry")); 
   gtk_widget_hide(load_file_dlg.self);

   /* fill struct with target, extensions, options */
   sob_load_settings.filename =  gtk_entry_get_text(entry);
   if (stat( sob_load_settings.filename, &s) ) { 
      /* error! file does not exist! */
      printf("Error %X: cannot load file '%s'\n", errno, 
            sob_load_settings.filename);
      gtk_widget_show(load_file_dlg.self);
      return;
   }
   
   /* disassembly options */
   children = load_file_dlg.disasm.box->box.children;
   for ( x = 0; (ptr = g_list_nth(children, x)); x++) {
      char *val;
      GtkBoxChild *child = g_list_nth_data(children, x);//ptr->data;
      GtkWidget *widget = child->widget;
      if ( (val = (char *) gtk_object_get_data(GTK_OBJECT(widget), "value")) &&
         gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(widget) )) {
            sob_load_settings.disasm_method = val;
      }
   } 
   
   
   /* format options */
   gtk_container_foreach(load_file_dlg.format.box, 
                           loadfile_ok_foreach, &option);

   sob_load_settings.format =  gtk_entry_get_text(
           GTK_ENTRY(lookup_widget( load_file_dlg.self, "lfd_format_entry")) );
   sob_load_settings.format_options = option;
   option = 0;

   /* cpu options */
   gtk_container_foreach(load_file_dlg.cpu.box, 
                           loadfile_ok_foreach, &option);
   sob_load_settings.cpu =  gtk_entry_get_text(
           GTK_ENTRY(lookup_widget( load_file_dlg.self, "lfd_cpu_entry")) );
   sob_load_settings.cpu_options = option;
   option = 0;

   /* asm options */
   gtk_container_foreach(load_file_dlg.asmblr.box, 
                           loadfile_ok_foreach, &option);
   sob_load_settings.asmblr =  gtk_entry_get_text(
           GTK_ENTRY(lookup_widget( load_file_dlg.self, "lfd_asm_entry")) );
   sob_load_settings.asm_options = option;
   option = 0;

   /* hll options */
   gtk_container_foreach(load_file_dlg.hll.box, 
                           loadfile_ok_foreach, &option);
   sob_load_settings.hll =  gtk_entry_get_text(
           GTK_ENTRY(lookup_widget( load_file_dlg.self, "lfd_hll_entry")) );
   sob_load_settings.hll_options = option;
   option = 0;

   load_and_disasm_target(&sob_load_settings);
   gtk_entry_set_text( entry, "");

   return;
}


void
selectfile_dlg_ok                      (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(select_file_dlg);

   return;
}


void
loadfile_dlg_cancel                    (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(load_file_dlg.self);
   gtk_entry_set_text(
         GTK_ENTRY(lookup_widget( load_file_dlg.self, "lfd_file_entry")), 
         ""  );
   return;
}


void
selectfile_dlg_cancel                  (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_widget_hide(select_file_dlg);
   return;
}


void
loadfile_dlg_asm_change                (GtkEditable     *editable,
                                        gpointer         user_data)
{
   char filename[PATH_MAX];
   GtkEntry *entry = 
      GTK_ENTRY(lookup_widget(load_file_dlg.self, "lfd_asm_entry")); 

   /* create options based on .dat file */
   sprintf(filename, "%s/asm/%s.dat", env_get_home(), 
         gtk_entry_get_text(entry));

   create_dlg_from_datfile( filename, &load_file_dlg.asmblr);
   return;
}


void
loadfile_dlg_hll_change                (GtkEditable     *editable,
                                        gpointer         user_data)
{
   char filename[PATH_MAX];
   GtkEntry *entry = 
      GTK_ENTRY(lookup_widget(load_file_dlg.self, "lfd_hll_entry")); 

   /* create options based on .dat file */
   sprintf(filename, "%s/lang/%s.dat", env_get_home(), 
         gtk_entry_get_text(entry));

   create_dlg_from_datfile( filename, &load_file_dlg.hll);
   return;

}


void
on_bastard_howto1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_bastard_manual1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_api_reference1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_db_schema1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_scripting_manual1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
opentgt_release_event                  (GtkButton       *button,
                                                 gpointer         user_data)
{
   on_load_target1_activate(button,  user_data);

  return FALSE;
}


void
saveas_asm_ok                      (GtkButton       *button,
                                        gpointer         user_data)
{
   char *filename;

   filename = gtk_file_selection_get_filename(select_file_dlg);
   if (filename[0]) 
      target_save_lst( filename );
   gtk_widget_hide(select_file_dlg);

   return;
}

void
on_saveas_asm_file1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   char *filename;

   if (select_file_dlg == NULL) {
      select_file_dlg = create_SelectFileDlg(); 
   }

   if (sob_load_settings.filename[0]) {
      gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (
            select_file_dlg)->ok_button), "clicked", 
            (GtkSignalFunc) saveas_asm_ok, select_file_dlg );
      gtk_widget_show(select_file_dlg);
   }
}


void
saveas_lst_ok                      (GtkButton       *button,
                                        gpointer         user_data)
{
   char *filename;

   filename = gtk_file_selection_get_filename(select_file_dlg);
   if (filename[0]) 
      target_save_lst( filename );
   gtk_widget_hide(select_file_dlg);

   return;
}

void
on_saveas_lst_file1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   if (select_file_dlg == NULL) {
      select_file_dlg = create_SelectFileDlg(); 
   }

   if (sob_load_settings.filename[0]) {
      gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (
            select_file_dlg)->ok_button), "clicked", 
            (GtkSignalFunc) saveas_lst_ok, select_file_dlg );
      gtk_widget_show(select_file_dlg);
   }
}




void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_edit_settings1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_edit_font1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_findtext1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_find_mnemonic1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_find_operand1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_findbytes1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_jump_to_address1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_disassemble_from_here1_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_sob_help1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


