/*
 * sys_initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */
#include <ctype.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <bastard.h>

#include "interface.h"
#include "support.h"
#include "sob_ui.h"
int caught_sig_kill;

//______________________________________________________________user_kill()
void user_kill( int sig) {
   if (! caught_sig_kill ) {
      caught_sig_kill = 1;
      printf("GodDAMNIT! I can't do ANYTHING!\n");
      sys_quit();
      env_set_flag( QUIT_NOW );
   }
   printf("bastard! killed by signal %d\n", sig);
   exit(sig);
}
//______________________________________________________________ReadPrefs()
void ReadPrefs( char* filename ){
   /* to be written :P */
   FILE *f;
   char group[64] = {0}, name[256], buf[256];
   f = fopen(filename, "r");
   /* allow comments  and GROUP.NAME=VALUE lines */
   while ( fscanf(f, "%[# ]%[^\n]\n", name, buf) > 0 ||
         fscanf(f, "%[^.].%[^ =] = %s\n", group, name, buf) > 0){
      if (  group[0] &&
          ! env_set_setting(group, name, buf) &&
          ! env_set_option(name) ){
         printf("Invalid Option %s.%s = %s\n", group, name, buf);
      }
      group[0] = '\0';
   }
   fclose(f);
   return;
}

//___________________________________________________________________main()
int init_bastard(char **argv){
   //int x, retVal = 0;
   //FILE *fTemp, *oldIN, *oldOUT, *oldERR, *newSTR;
   //char tmpBuf[128]; //, *tmp, *script;
   //struct stat tmpStat;
   struct DISASM_ENV *disasm_env;
   struct DISASM_PREFS *disasm_prefs;
   struct DISASM_TGT *target;

   /* set up rudimentary exception handling :P */
   caught_sig_kill = 0;

   /* prepare bastard-settings structure pointers */
   disasm_env = env_get_env();
   disasm_prefs = env_get_prefs();
   target = env_get_target();

	if (! sys_find_home(disasm_env->home, PATH_MAX, argv)) {
		printf("Error in bastard setup: cannot find $BASTARD_HOME!\n"
				 "\tForcing to /usr/local/bastard...\n");
		strcpy((char *)disasm_env->home, "/usr/local/bastard");
	}
   /* + Set some non-vital defaults */
   sys_init(disasm_env->home); /* set defaults, start DB && interpreter */

   /* + Apply settings in RC scripts */
   /*if ( ! stat("/etc/bastard.rc", &tmpStat)) ReadPrefs("/etc/bastard.rc");
   sprintf(tmpBuf, "%s/.bastard/bastard.rc", getenv("HOME"));
   if ( ! stat(tmpBuf, &tmpStat)) ReadPrefs(tmpBuf);*/

   /* + Trap User Signals */
   signal( SIGKILL, user_kill);
   signal( SIGABRT, user_kill);
   signal( SIGINT, user_kill);
   signal( SIGTERM, user_kill);
   signal( SIGSEGV, user_kill);
   signal( SIGPIPE, SIG_IGN);

   return(0);
}

int
main (int argc, char *argv[])
{
  GtkWidget *window1;

  /* 1. init the bastard */
  init_bastard(argv);

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_window1 ();
  gtk_widget_show (window1);

  init_ui_main(window1);
  gtk_main ();
  return 0;
}


