#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <bastard.h>

#include "support.h"
#include "db/db_query.h"


extern GtkWidget *sob_main_window;


int clear_textbox(GtkText *t){
	gtk_text_set_point( t,0 );
	gtk_text_forward_delete( t, gtk_text_get_length( t ) );
	return(1);
}

/* fill/refresh the various columned lists */
void FillSections( void ) {
	db_table *t;
	db_field *name, *addr, *size, *perm;
	db_result *r, *head;
	char *str[4]; 					/* pointers to strings for CList */
	char addr_buf[16], size_buf[16], perm_buf[32];
	
   GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "SectionList");
	
	t = db_table_by_name(db_schema_by_name("TARGET"), "SECTION");
	name = db_field_by_name(t, "name");
	addr = db_field_by_name(t, "rva");
	size = db_field_by_name(t, "size");
	perm = db_field_by_name(t, "flags");
	str[1] = addr_buf;
	str[2] = size_buf;
	str[3] = perm_buf;
	
	r = head = db_table_get(t);
	
	while (r) {
		str[0] = r->data + name->offset;
		sprintf( addr_buf, "0x%08X", *(int *)(r->data + addr->offset));
		sprintf( size_buf, "0x%X", *(int *)(r->data + size->offset));
		/* TODO: translate PERMS to human-readable values */
		sprintf( perm_buf, "0x%08X", *(int *)(r->data + perm->offset));
		
		gtk_clist_append( l, str);
		r = r->next;
	}
	
	db_result_free(head);
	return;
}


void RefreshSections( void ){
   GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "SectionList");
	gtk_clist_clear( l );
	FillSections();
}


void FillNames( void ) {
	db_table *t;
	db_field *name, *addr, *type;
	db_result *r, *head;
	char *str[3]; 					
	char addr_buf[16], type_buf[32];
   GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "NameList");
	
	
	t = db_table_by_name(db_schema_by_name("TARGET"), "NAME");
	name = db_field_by_name(t, "name");
	addr = db_field_by_name(t, "rva");
	type = db_field_by_name(t, "type");
	str[1] = addr_buf;
	str[2] = type_buf;
	
	r = head = db_table_get(t);
	
	while (r) {
		str[0] = r->data + name->offset;
		sprintf( addr_buf, "0x%08X", *(int *)(r->data + addr->offset));
		sprintf( type_buf, "0x%08X", *(int *)(r->data + type->offset));
		
		gtk_clist_append( l, str);
		r = r->next;
	}
	
	db_result_free(head);
	return;
}


void RefreshNames( void ){
   GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "NameList");
	gtk_clist_clear( l );
	FillNames();
} 


void FillFunctions( void ) {
	db_table *t;
	db_field *name, *addr, *refto, *reffrom, *comment;
	db_result *r, *head;
	char *str[5]; 					
	char addr_buf[16], xrefto[32], xreffrom[32], cmt[256];
   GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "FuncList");
	
	t = db_table_by_name(db_schema_by_name("TARGET"), "FUNCTION");
	addr = db_field_by_name(t, "rva");
	str[1] = addr_buf;
	str[0] = str[2] = str[3] = str[4] = "not implemented";
	
	r = head = db_table_get(t);
	
	while (r) {
		sprintf( addr_buf, "0x%08X", *(int *)(r->data + addr->offset));
		
		gtk_clist_append( l, str);
		r = r->next;
	}
	
	db_result_free(head);
	return;
} 


void RefreshFunctions( void ){
   GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "FuncList");
	gtk_clist_clear( l );
	FillFunctions();
}


void FillImports( void ) {
	db_table *t;
	db_field *name, *addr, *library, *xrefs;
	db_result *r, *head;
	char *str[4]; 					
	char addr_buf[16], lib_buf[32], xref_buf[32];
   GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "ImportList");
		
	t = db_table_by_name(db_schema_by_name("TARGET"), "IMPORT_ADDR");
	addr = db_field_by_name(t, "rva");
	str[1] = addr_buf;
	str[0] = str[3] = str[2] = "not implemented";
	
	r = head = db_table_get(t);
	
	while (r) {
		/* TODO: lookup name, library, xrefs for each import */
		sprintf( addr_buf, "0x%08X", *(int *)(r->data + addr->offset));
		
		gtk_clist_append( l, str);
		r = r->next;
	}
	
	db_result_free(head);
	return;
} 


void RefreshImports( void ){
   GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "ImportList");
	gtk_clist_clear( l );
	FillImports();
}


void FillStrings( void ) {
	db_table *t;
	db_field *text, *addr;
	db_result *r, *head;
	char *str[3]; 					
	char addr_buf[16], xrefs_buf[32];
	GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "StringList");
		
	t = db_table_by_name(db_schema_by_name("TARGET"), "STRING");
	text = db_field_by_name(t, "text");
	addr = db_field_by_name(t, "rva");
	str[1] = addr_buf;
	str[2] = "not implemented";
	
	r = head = db_table_get(t);
	
	while (r) {
		str[0] = r->data + text->offset;
		sprintf( addr_buf, "0x%08X", *(int *)(r->data + addr->offset));
		/* TODO: calculate XREFs to this string */
		
		gtk_clist_append( l, str);
		r = r->next;
	}
	
	db_result_free(head);
	return;
}


void RefreshStrings( void ){
	GtkCList *l = (GtkCList *) lookup_widget(sob_main_window, "StringList");
	gtk_clist_clear( l );
	FillStrings();
} 


void FillHeader( char *text ) {	
	GtkText *t = (GtkText *) lookup_widget(sob_main_window, "HeaderView");
	clear_textbox(t);
	/* TODO : use global color scheme for this */
	gtk_text_insert( t, NULL, NULL, NULL, text, -1 );
	return;
}
